# Generated by Django 5.1.1 on 2024-10-05 10:42

import django.core.validators
import django.db.models.deletion
import django.utils.timezone
import django_ckeditor_5.fields
import django_jsonform.models.fields
import sorl.thumbnail.fields
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="PostCategory",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created_at",
                    models.DateTimeField(auto_now_add=True, verbose_name="Created at"),
                ),
                (
                    "modified_at",
                    models.DateTimeField(auto_now=True, verbose_name="Modified at"),
                ),
                (
                    "title",
                    models.CharField(
                        db_comment="Stores the unique title of the instance.",
                        help_text="Enter a unique title.",
                        max_length=255,
                        unique=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "title_en",
                    models.CharField(
                        db_comment="Stores the unique title of the instance.",
                        help_text="Enter a unique title.",
                        max_length=255,
                        null=True,
                        unique=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "title_fa",
                    models.CharField(
                        db_comment="Stores the unique title of the instance.",
                        help_text="Enter a unique title.",
                        max_length=255,
                        null=True,
                        unique=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "title_ar",
                    models.CharField(
                        db_comment="Stores the unique title of the instance.",
                        help_text="Enter a unique title.",
                        max_length=255,
                        null=True,
                        unique=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "slug",
                    models.SlugField(
                        allow_unicode=True,
                        db_comment="Stores the URL-friendly slug derived from the title.",
                        help_text="URL-friendly slug from the title.",
                        max_length=255,
                        unique=True,
                        verbose_name="Slug",
                    ),
                ),
                (
                    "is_published",
                    models.BooleanField(
                        db_comment="Indicates if the category is published (true) or hidden from non-staff users (false).",
                        default=True,
                        help_text="Indicate whether this category is currently published and should be displayed to all users. If unpublished, only staff users can view the category.",
                        verbose_name="Is Published",
                    ),
                ),
            ],
            options={
                "verbose_name": "Category",
                "verbose_name_plural": "Categories",
                "db_table": "sage_post_category",
                "db_table_comment": "Table for categorizing blog posts",
                "default_manager_name": "objects",
            },
        ),
        migrations.CreateModel(
            name="PostTag",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created_at",
                    models.DateTimeField(auto_now_add=True, verbose_name="Created at"),
                ),
                (
                    "modified_at",
                    models.DateTimeField(auto_now=True, verbose_name="Modified at"),
                ),
                (
                    "title",
                    models.CharField(
                        db_comment="Stores the unique title of the instance.",
                        help_text="Enter a unique title.",
                        max_length=255,
                        unique=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "title_en",
                    models.CharField(
                        db_comment="Stores the unique title of the instance.",
                        help_text="Enter a unique title.",
                        max_length=255,
                        null=True,
                        unique=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "title_fa",
                    models.CharField(
                        db_comment="Stores the unique title of the instance.",
                        help_text="Enter a unique title.",
                        max_length=255,
                        null=True,
                        unique=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "title_ar",
                    models.CharField(
                        db_comment="Stores the unique title of the instance.",
                        help_text="Enter a unique title.",
                        max_length=255,
                        null=True,
                        unique=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "slug",
                    models.SlugField(
                        allow_unicode=True,
                        db_comment="Stores the URL-friendly slug derived from the title.",
                        help_text="URL-friendly slug from the title.",
                        max_length=255,
                        unique=True,
                        verbose_name="Slug",
                    ),
                ),
                (
                    "is_published",
                    models.BooleanField(
                        db_comment="Indicates if the tag is published (true) or hidden from non-staff users (false).",
                        default=True,
                        help_text="Indicate whether this tag is currently published and should be displayed to all users. If unpublished, only staff users can view the tag.",
                        verbose_name="Is Published",
                    ),
                ),
            ],
            options={
                "verbose_name": "Tag",
                "verbose_name_plural": "Tags",
                "db_table": "sage_post_tag",
                "db_table_comment": "Table for preserving blog post tags",
                "default_manager_name": "objects",
            },
        ),
        migrations.CreateModel(
            name="Post",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created_at",
                    models.DateTimeField(auto_now_add=True, verbose_name="Created at"),
                ),
                (
                    "modified_at",
                    models.DateTimeField(auto_now=True, verbose_name="Modified at"),
                ),
                (
                    "title",
                    models.CharField(
                        db_comment="Stores the unique title of the instance.",
                        help_text="Enter a unique title.",
                        max_length=255,
                        unique=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "title_en",
                    models.CharField(
                        db_comment="Stores the unique title of the instance.",
                        help_text="Enter a unique title.",
                        max_length=255,
                        null=True,
                        unique=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "title_fa",
                    models.CharField(
                        db_comment="Stores the unique title of the instance.",
                        help_text="Enter a unique title.",
                        max_length=255,
                        null=True,
                        unique=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "title_ar",
                    models.CharField(
                        db_comment="Stores the unique title of the instance.",
                        help_text="Enter a unique title.",
                        max_length=255,
                        null=True,
                        unique=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "slug",
                    models.SlugField(
                        allow_unicode=True,
                        db_comment="Stores the URL-friendly slug derived from the title.",
                        help_text="URL-friendly slug from the title.",
                        max_length=255,
                        unique=True,
                        verbose_name="Slug",
                    ),
                ),
                (
                    "keywords",
                    django_jsonform.models.fields.JSONField(
                        blank=True,
                        db_comment="List of SEO keywords associated with the page.",
                        help_text="A list of keywords relevant to the page content, used for SEO purposes.",
                        null=True,
                        verbose_name="SEO Keywords",
                    ),
                ),
                (
                    "meta_description",
                    models.TextField(
                        blank=True, null=True, verbose_name="SEO Description"
                    ),
                ),
                (
                    "og_title",
                    models.CharField(
                        blank=True,
                        db_comment="The title of the webpage for Open Graph protocol.",
                        help_text="The title of the webpage. Example: 'The Amazing Spider-Man - Movie Review'",
                        max_length=255,
                        null=True,
                        verbose_name="OG Title",
                    ),
                ),
                (
                    "og_type",
                    models.CharField(
                        blank=True,
                        db_comment="The type of the content for Open Graph protocol. Common values include 'website', 'article', 'video', etc.",
                        help_text="The type of the content. Common values: 'website', 'article', 'video', etc. Example: 'article'",
                        max_length=50,
                        null=True,
                        verbose_name="OG Type",
                    ),
                ),
                (
                    "og_image",
                    models.URLField(
                        blank=True,
                        db_comment="The URL of the image that represents the webpage for Open Graph protocol.",
                        help_text="The URL of the image that represents the webpage. Example: 'https://www.example.com/image.jpg'",
                        null=True,
                        validators=[django.core.validators.URLValidator()],
                        verbose_name="OG Image",
                    ),
                ),
                (
                    "og_description",
                    models.TextField(
                        blank=True,
                        db_comment="A description of the webpage content for Open Graph protocol.",
                        help_text="A description of the webpage content. Example: 'A comprehensive review of the latest Spider-Man movie, including storyline, character development, and special effects.'",
                        null=True,
                        verbose_name="OG Description",
                    ),
                ),
                (
                    "og_url",
                    models.URLField(
                        blank=True,
                        db_comment="The URL of the webpage for Open Graph protocol.",
                        help_text="The URL of the webpage. Example: 'https://www.example.com/page.html'",
                        null=True,
                        validators=[django.core.validators.URLValidator()],
                        verbose_name="OG URL",
                    ),
                ),
                (
                    "og_site_name",
                    models.CharField(
                        blank=True,
                        db_comment="The name of the website for Open Graph protocol.",
                        help_text="The name of the website. Example: 'Example Website'",
                        max_length=255,
                        null=True,
                        verbose_name="OG Site Name",
                    ),
                ),
                (
                    "og_locale",
                    models.CharField(
                        blank=True,
                        db_comment="The locale of the content for Open Graph protocol. Example: 'en_US'.",
                        help_text="The locale of the content. Common values: 'en_US', 'fr_FR', etc. Example: 'en_US'",
                        max_length=10,
                        null=True,
                        validators=[
                            django.core.validators.RegexValidator(
                                message="Enter a valid locale identifier like en_US",
                                regex="^[a-z]{2}_[A-Z]{2}$",
                            )
                        ],
                        verbose_name="OG Locale",
                    ),
                ),
                (
                    "article_author",
                    models.CharField(
                        blank=True,
                        db_comment="The name of the author of the article for Open Graph protocol.",
                        help_text="The name of the author of the article. Example: 'John Doe'",
                        max_length=255,
                        null=True,
                        verbose_name="Article Author",
                    ),
                ),
                (
                    "json_ld",
                    django_jsonform.models.fields.JSONField(
                        blank=True,
                        db_comment="JSON-LD structured data for enhancing search engine listings with rich snippets.",
                        help_text="Structured JSON-LD data for rich snippets. Enter valid JSON.",
                        null=True,
                    ),
                ),
                (
                    "alternate_text",
                    models.CharField(
                        blank=True,
                        help_text="Write about picture for SEO",
                        max_length=110,
                        null=True,
                        validators=[
                            django.core.validators.MaxLengthValidator(150),
                            django.core.validators.MinLengthValidator(3),
                        ],
                        verbose_name="Picture Alternate Text",
                    ),
                ),
                (
                    "alternate_text_en",
                    models.CharField(
                        blank=True,
                        help_text="Write about picture for SEO",
                        max_length=110,
                        null=True,
                        validators=[
                            django.core.validators.MaxLengthValidator(150),
                            django.core.validators.MinLengthValidator(3),
                        ],
                        verbose_name="Picture Alternate Text",
                    ),
                ),
                (
                    "alternate_text_fa",
                    models.CharField(
                        blank=True,
                        help_text="Write about picture for SEO",
                        max_length=110,
                        null=True,
                        validators=[
                            django.core.validators.MaxLengthValidator(150),
                            django.core.validators.MinLengthValidator(3),
                        ],
                        verbose_name="Picture Alternate Text",
                    ),
                ),
                (
                    "alternate_text_ar",
                    models.CharField(
                        blank=True,
                        help_text="Write about picture for SEO",
                        max_length=110,
                        null=True,
                        validators=[
                            django.core.validators.MaxLengthValidator(150),
                            django.core.validators.MinLengthValidator(3),
                        ],
                        verbose_name="Picture Alternate Text",
                    ),
                ),
                (
                    "width_field",
                    models.PositiveSmallIntegerField(
                        blank=True,
                        editable=False,
                        help_text="size of picture's Width",
                        null=True,
                        verbose_name="Picture Width",
                    ),
                ),
                (
                    "height_field",
                    models.PositiveSmallIntegerField(
                        blank=True,
                        editable=False,
                        help_text="size of picture's Height",
                        null=True,
                        verbose_name="Picture Height",
                    ),
                ),
                (
                    "description",
                    django_ckeditor_5.fields.CKEditor5Field(
                        db_comment="Stores a detailed description of the instance.",
                        help_text="Enter a detailed description of the item. This can include its purpose, characteristics, and any other relevant information.",
                        verbose_name="Description",
                    ),
                ),
                (
                    "description_en",
                    django_ckeditor_5.fields.CKEditor5Field(
                        db_comment="Stores a detailed description of the instance.",
                        help_text="Enter a detailed description of the item. This can include its purpose, characteristics, and any other relevant information.",
                        null=True,
                        verbose_name="Description",
                    ),
                ),
                (
                    "description_fa",
                    django_ckeditor_5.fields.CKEditor5Field(
                        db_comment="Stores a detailed description of the instance.",
                        help_text="Enter a detailed description of the item. This can include its purpose, characteristics, and any other relevant information.",
                        null=True,
                        verbose_name="Description",
                    ),
                ),
                (
                    "description_ar",
                    django_ckeditor_5.fields.CKEditor5Field(
                        db_comment="Stores a detailed description of the instance.",
                        help_text="Enter a detailed description of the item. This can include its purpose, characteristics, and any other relevant information.",
                        null=True,
                        verbose_name="Description",
                    ),
                ),
                (
                    "is_published",
                    models.BooleanField(
                        db_comment="Indicates if the post is published (true) or hidden from non-staff users (false).",
                        default=True,
                        help_text="Indicate whether this post is currently published and should be displayed to all users. If unpublished, only staff users can view the post.",
                        verbose_name="Is Published",
                    ),
                ),
                (
                    "summary",
                    models.CharField(
                        db_comment="A brief summary of the blog post.",
                        help_text="Enter a brief summary of the post, up to 140 characters.",
                        max_length=140,
                        null=True,
                        verbose_name="Summary",
                    ),
                ),
                (
                    "summary_en",
                    models.CharField(
                        db_comment="A brief summary of the blog post.",
                        help_text="Enter a brief summary of the post, up to 140 characters.",
                        max_length=140,
                        null=True,
                        verbose_name="Summary",
                    ),
                ),
                (
                    "summary_fa",
                    models.CharField(
                        db_comment="A brief summary of the blog post.",
                        help_text="Enter a brief summary of the post, up to 140 characters.",
                        max_length=140,
                        null=True,
                        verbose_name="Summary",
                    ),
                ),
                (
                    "summary_ar",
                    models.CharField(
                        db_comment="A brief summary of the blog post.",
                        help_text="Enter a brief summary of the post, up to 140 characters.",
                        max_length=140,
                        null=True,
                        verbose_name="Summary",
                    ),
                ),
                (
                    "picture",
                    sorl.thumbnail.fields.ImageField(
                        db_comment="Image file associated with the blog post.",
                        height_field="height_field",
                        help_text="Upload an image representing the post. Ideal dimensions are [x] by [y].",
                        upload_to="blog/posts/pictures/",
                        verbose_name="Picture of Post",
                        width_field="width_field",
                    ),
                ),
                (
                    "banner",
                    sorl.thumbnail.fields.ImageField(
                        blank=True,
                        db_comment="Image file associated with the blog post.",
                        help_text="Upload an image representing the post. Ideal dimensions are [x] by [y].",
                        null=True,
                        upload_to="blog/posts/banners/",
                        verbose_name="Banner of Post Detail",
                    ),
                ),
                (
                    "published_at",
                    models.DateTimeField(
                        default=django.utils.timezone.now,
                        help_text="The date and time when the post was published.",
                        verbose_name="Published At",
                    ),
                ),
                (
                    "category",
                    models.ForeignKey(
                        db_comment="The category to which the blog post belongs.",
                        help_text="Choose the category of the post.",
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="posts",
                        to="sage_blog.postcategory",
                        verbose_name="Category",
                    ),
                ),
                (
                    "tags",
                    models.ManyToManyField(
                        help_text="Select or add tags to categorize the post.",
                        related_name="posts",
                        to="sage_blog.posttag",
                        verbose_name="Tags",
                    ),
                ),
            ],
            options={
                "verbose_name": "Post",
                "verbose_name_plural": "Posts",
                "db_table": "sage_post",
                "db_table_comment": "Table for preserving blog posts",
                "default_manager_name": "objects",
            },
        ),
        migrations.CreateModel(
            name="PostFaq",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created_at",
                    models.DateTimeField(auto_now_add=True, verbose_name="Created at"),
                ),
                (
                    "modified_at",
                    models.DateTimeField(auto_now=True, verbose_name="Modified at"),
                ),
                (
                    "question",
                    models.CharField(
                        db_comment="The question of the FAQ. Limited to 80 characters.",
                        help_text="Enter the FAQ question. Keep it clear and concise to aid easy understanding.",
                        max_length=150,
                        verbose_name="Question",
                    ),
                ),
                (
                    "question_en",
                    models.CharField(
                        db_comment="The question of the FAQ. Limited to 80 characters.",
                        help_text="Enter the FAQ question. Keep it clear and concise to aid easy understanding.",
                        max_length=150,
                        null=True,
                        verbose_name="Question",
                    ),
                ),
                (
                    "question_fa",
                    models.CharField(
                        db_comment="The question of the FAQ. Limited to 80 characters.",
                        help_text="Enter the FAQ question. Keep it clear and concise to aid easy understanding.",
                        max_length=150,
                        null=True,
                        verbose_name="Question",
                    ),
                ),
                (
                    "question_ar",
                    models.CharField(
                        db_comment="The question of the FAQ. Limited to 80 characters.",
                        help_text="Enter the FAQ question. Keep it clear and concise to aid easy understanding.",
                        max_length=150,
                        null=True,
                        verbose_name="Question",
                    ),
                ),
                (
                    "answer",
                    models.TextField(
                        db_comment="Detailed answer to the FAQ question. Limited to 180 characters.",
                        help_text="Provide a detailed answer to the FAQ question. Aim for clarity and completeness.",
                        verbose_name="Answer",
                    ),
                ),
                (
                    "answer_en",
                    models.TextField(
                        db_comment="Detailed answer to the FAQ question. Limited to 180 characters.",
                        help_text="Provide a detailed answer to the FAQ question. Aim for clarity and completeness.",
                        null=True,
                        verbose_name="Answer",
                    ),
                ),
                (
                    "answer_fa",
                    models.TextField(
                        db_comment="Detailed answer to the FAQ question. Limited to 180 characters.",
                        help_text="Provide a detailed answer to the FAQ question. Aim for clarity and completeness.",
                        null=True,
                        verbose_name="Answer",
                    ),
                ),
                (
                    "answer_ar",
                    models.TextField(
                        db_comment="Detailed answer to the FAQ question. Limited to 180 characters.",
                        help_text="Provide a detailed answer to the FAQ question. Aim for clarity and completeness.",
                        null=True,
                        verbose_name="Answer",
                    ),
                ),
                (
                    "post",
                    models.ForeignKey(
                        db_comment="The post to which the faq belongs.",
                        help_text="Choose the post of the faq.",
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="faqs",
                        to="sage_blog.post",
                        verbose_name="Post",
                    ),
                ),
            ],
            options={
                "verbose_name": "FAQ",
                "verbose_name_plural": "FAQ",
                "db_table": "sage_post_faqs",
                "db_table_comment": "Table storing frequently asked questions and their answers for user reference.",
            },
        ),
    ]
